package RTC;


/**
* RTC/Waypoint3D.java .
* IDL-to-Java\u30b3\u30f3\u30d1\u30a4\u30e9(\u30dd\u30fc\u30bf\u30d6\u30eb)\u3001\u30d0\u30fc\u30b8\u30e7\u30f3"3.2"\u306b\u3088\u3063\u3066\u751f\u6210\u3055\u308c\u307e\u3057\u305f
* idl/InterfaceDataTypes.idl\u304b\u3089
* 2016\u5e7411\u67081\u65e5 15\u664208\u520616\u79d2 JST
*/

public final class Waypoint3D implements org.omg.CORBA.portable.IDLEntity
{

  /// Location of the waypoint.
  public RTC.Pose3D target = null;

  /// How far away from the waypoint is considered success (radius in metres).
  public double distanceTolerance = (double)0;

  /// How much off the target heading is considered success (in radians).
  public double headingTolerance = (double)0;

  /// Target time to arrive at the waypoint by.
  public RTC.Time timeLimit = null;

  /// Maximum sped to travel at while heading to the waypoint.
  public RTC.Velocity3D maxSpeed = null;

  public Waypoint3D ()
  {
  } // ctor

  public Waypoint3D (RTC.Pose3D _target, double _distanceTolerance, double _headingTolerance, RTC.Time _timeLimit, RTC.Velocity3D _maxSpeed)
  {
    target = _target;
    distanceTolerance = _distanceTolerance;
    headingTolerance = _headingTolerance;
    timeLimit = _timeLimit;
    maxSpeed = _maxSpeed;
  } // ctor

} // class Waypoint3D
